#include "StdAfx.h"
#include "SimpleImageShapePropertyAccessor.h"

#include "ScriptletConstant.h"
#include "SimpleImageShape.h"
#include "Application.h"

REGISTER_PROPERTY_ACCESSOR(SCRIPTLET_IMAGE_NODE, SimpleImageShapePropertyAccessor)
BOOL SimpleImageShapePropertyAccessor::SetProperty(CComponent* pTarget, LPCTSTR property, CComVariant value)
{
	BOOL bSuccess = __super::SetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CSimpleImageShape* image = dynamic_cast<CSimpleImageShape*>(pTarget);
		if (image == NULL) return bSuccess;

		USES_CONVERSION;
		//src
		if (_tcsicmp(SCRIPTLET_SOURCE_NODE, property) == 0)
		{
			if (value.vt == VT_BSTR)
			{				
				image->SetImage(OLE2CT(value.bstrVal));
			}
			else if (value.vt == VT_UI4)
			{
				IImage* pImage = reinterpret_cast<IImage*>(value.ulVal);
				image->SetImage(pImage);				
			}
		}
	}
	return bSuccess;
}
BOOL SimpleImageShapePropertyAccessor::GetProperty(CComponent* pTarget, LPCTSTR property, CComVariant& value)
{
	BOOL bSuccess = __super::GetProperty(pTarget, property, value);
	if (bSuccess == FALSE)
	{
		CSimpleImageShape* image = dynamic_cast<CSimpleImageShape*>(pTarget);
		if (image == NULL) return bSuccess;

		USES_CONVERSION;
		//src
		if (_tcsicmp(SCRIPTLET_SOURCE_NODE, property) == 0)
		{			
		}
	}
	return bSuccess;
}